rm(list=ls(all=TRUE))
library(MCMCpack)
library(mvtnorm)
library(tensor)
library(mnormt)
library(rmgarch)

SMC=function(N,Ti,dim,k,C,D,obs)
{
mu=matrix(rep(0,dim),nrow=1,ncol=dim)
ESS<-rep(N/2,Ti)
NESS<-N/2
xs<-array(rep(diag(dim),N*(Ti+1)),dim=c(dim,dim,N,Ti+1))
Weight=array(rep(1/N,N*(Ti+1)),dim=c(N,Ti+1))
A=array(rep(diag(dim),(Ti)),dim=c(dim,dim,Ti+1))
beta=diag(dim)
xt=array(rep(0,(Ti+1)*dim),dim=c(Ti+1,dim))
Dt=array(rep(0,(Ti+1)*dim),dim=c(Ti+1,dim))
at=array(rep(0,(Ti+1)*dim),dim=c(Ti+1,dim))

######for t=0##############
####prior for A and x
for (i in 1:N)
{
xs[,,i,1]=riwish(k,(k-dim-1)*diag(dim))              
}
for (i in 1:dim)
{
xt[1,i]=weighted.mean(xs[i,i,,1],Weight[,1])
}


######for t=1##############
for (i in 1:dim)
{
Dt[1,i]=D
}

for (i in 1:dim)
{
at[1,i]=rgamma(1,C,scale=Dt[1,i])
}

A[,,1]=diag(c(at[1,]))
for (i in 1:N)
{
xs[,,i,2]=riwish(k,(k-dim-1)*(A[,,1])%*% xs[,,i,1] %*% t(A[,,1]))           
}
for (i in 1:dim)
{
xt[2,i]=weighted.mean(xs[i,i,,2],Weight[,2])
}

######for t=2...Ti#######
for (i in 1:dim)
{
Dt[2,i]=1/(1/Dt[1,i]+(k-dim-1)*xt[1,i]/xt[2,i]/2)
}
for (i in 1:dim)
{
at[2,i]=(Dt[2,i])*(C+(k-2*dim)/2)
}

A[,,2]=diag(c(at[2,]))
t<-3
while (t<(Ti+2))
{
####generate A and phi and SMC####
for (i in 1:N)
     {        
      
       xs[,,i,t]=riwish(k,(k-dim-1)*A[,,t-1]%*% xs[,,i,t-1] %*% t(A[,,t-1]))
   part1=dmvnorm(obs[t-1,],mu,(xs[,,i,t]))
   Weight[i,t-1]=Weight[i,t-2]*part1
     }
      Weight[,t-1]=Weight[,t-1]/sum(Weight[,t-1])
      ESS[t-2]=1/sum(Weight[,t-1]^2)
    if (ESS[t-2]<NESS)
	   {
               index=sample(N,N,replace=TRUE,prob=Weight[,t-1])
                xs[,,,t]=xs[,,index,t]
               Weight[,t-1]=rep(1/N,N)
          }
for (i in 1:dim)
{
xt[t,i]=weighted.mean(xs[i,i,,t],Weight[,t]) 
}

for (i in 1:dim)
{
Dt[t,i]=1/(1/Dt[t-1,i]+(k-dim-1)*xt[t-1,i]/xt[t,i]/2)
}

for (i in 1:dim) 
{
at[t,i]=(Dt[t,i])*(C+t*(k-2*dim)/2)
}
 
A[,,t]=diag(c(at[t,]))
t=t+1
}
meanX=array(rep(0,Ti*dim^2),dim=c(Ti,dim,dim))
for (i in 1:Ti)
{
for (j in 1:N)
{
meanX[i,,]=xs[,,j,i+1]*Weight[j,i+1]+meanX[i,,]
}
}
return(X=meanX) 
}


M=read.table("SimRtns.txt",header=T)
N<-100#number of particles
Ti=999#number of Time
dim=2#dimention
k=100
C=1000000
D=0.000001
p=array(rep(0,Ti*dim^2*100),dim=c(Ti,dim,dim,100))
for (i in 1:100)
{
p[,,,i]=SMC(N,Ti,dim,k,C,D,as.matrix(M[,(2*i-1):(2*i)])
)
}





###################################################
####################################################
##################################################

V=read.table("SimVolss.txt",header=T)

##################################

mc=read.table("mcmcHt.txt",header=T)

ISVolErrs = function(tH, eH){
          # This function calculates the RMSE and MAE between True volatility (tH) and Estimated volatility (eH)
          # tH and eH are vectors of size Tx(2K), where T is sample size and K is dimension
          # columns of tH are H_11 H_12 H_21 and H_22
         T = nrow(tH)
         K = ncol(tH)/2
         rmse = 0.0
         mae = 0.0
         cc = c(1,2,4) # since we need only 1,2 and 4th cols
        for(t in 1:T){
              rmse = rmse + sqrt(mean((tH[t,cc] - eH[t,cc])^2 ))
              mae = mae + mean(as.numeric(abs(tH[t,cc] - eH[t,cc])))
        }
        #it returns average of RMSE and MAE over the sample size
        return(c(rmse/T, mae/T)) 

  }
smc=array(0*2000,dim=c(2,1000))
MC=array(0*2000,dim=c(2,1000))
for (t in 301:1000){
smc[,t]=ISVolErrs(V[t,],t(as.matrix(p[t-1,,,])))
MC[,t]=ISVolErrs(V[t,],mc[t-1,])
}




Vol=sqrt(V[,c(1,4)])
par(mfrow=c(2,2))
plot.ts(as.matrix(M[301:1000,1]),col="red")
plot.ts(as.matrix(M[301:1000,2]),col="red")
plot.ts(sqrt(mc[300:999,1,1]),ylim=c(0,3))
lines(Vol[301:1000,1],col="red")
lines(sqrt(mc[301:1000,1]),col="blue")
plot.ts(sqrt(p[300:999,2,2,1]),ylim=c(0,3))
lines(Vol[301:1000,2],col="red")
lines(sqrt(mc[301:1000,4]),col="blue")
